CREATE OR REPLACE PACKAGE "MAILER"
IS 
   PRAGMA SERIALLY_REUSABLE;

--######################################################################################################################
--######################################################################################################################
--  
--      
--        
--      SET_PARAMETER
--        
--######################################################################################################################
--######################################################################################################################


--      smtp.mail.ru

   
--######################################################################################################################
--        
--######################################################################################################################
-- GRANT READ (, WRITE) ON DIRECTORY SYS.MYDIRECT TO PUBLIC;  SYS.MYDIRECT - ,   
--    CREATE ANY DIRECTORY
-- CREATE PUBLIC SYNONIM mailer FOR mailer.mailer;
-- GRANT EXECUTE ON MAILER to PUBLIC;
   
   
--******************************************************************************
--     SET_PARAMETER, 
--******************************************************************************

g_mailhost    VARCHAR2(255);        -- SMTP- 
g_port        NUMBER;               --  SMTP-
g_mailer      VARCHAR2(255);        --    
g_name_sender VARCHAR2(255);        --   
g_sender      VARCHAR2(255);        -- from
g_organ       VARCHAR2(255) := null;-- 
g_adress      VARCHAR2(255);        -- to   
g_reply       VARCHAR2(255);        -- reply to
--g_adr_group   VARCHAR2(255);        --     

g_lang        VARCHAR2(2);          --     

g_cid         VARCHAR2(255);        --       
g_chunk       NUMBER;               --  ,      

g_unix        BOOLEAN;              --   -UNIX 
g_convert     BOOLEAN;              --  
                                    -- e  FALSE,     p_unix 
                                    --  -   
--     UNIX  
g_kode_ora_win     VARCHAR2(255);   --   
g_kode_post_win    VARCHAR2(255);   --   o
--    UNIX  
g_kode_ora_unix    VARCHAR2(255);
g_kode_post_unix   VARCHAR2(255);


--######################################################################################################################
--    -  
--######################################################################################################################
 PROCEDURE SET_PARAMETER;

--######################################################################################################################
--       -    CLOB
--######################################################################################################################
 PROCEDURE SET_KODE
     (p_unix  IN BOOLEAN DEFAULT FALSE -- ,  TRUE,    UNIX
     );

--######################################################################################################################
--      -    
--######################################################################################################################
 PROCEDURE SET_SENDER
     (p_kak  IN BOOLEAN DEFAULT FALSE -- ,  TRUE,   - ,  -  
     );

   
--######################################################################################################################
--     ,    
-- mailer.text_fix('TEXT_FIX','TEXT_FIX rezerve.ru');
--######################################################################################################################
 PROCEDURE TEXT_FIX
     (p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL          -- message text
     );

--######################################################################################################################
--        - " "<manager@maska>
-- mailer.TEXT_TO(l_to,'TEXT_TO',' _TO');
--######################################################################################################################
 PROCEDURE TEXT_TO
     (p_to          IN LONG,                  -- to
      p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL          -- message text
     );

--######################################################################################################################
--       ( 1  5  ), 
-- - ,   
-- :   ,   
-- mailer.text_unit( p_to => a1, p_subject=>' ', p_message=>'  10 ');
--######################################################################################################################
 PROCEDURE TEXT_UNIT
     (p_to          IN LONG,     -- to -  
      p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL          -- message text
     ); 

--######################################################################################################################
--   HTML     - " "<manager@maska>
-- mailer.HTML_fix('HTML_FIX','HTML_FIX rezerve.ru');
--######################################################################################################################
 PROCEDURE HTML_FIX
     (p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL          -- message text
     );
     
--######################################################################################################################
--   HTML     - " "<manager@maska>
-- mailer.HTML_TO(l_to,'HTML_TO',' HTML_TO');
--######################################################################################################################
 PROCEDURE HTML_TO
     (p_to          IN LONG,                  -- to
      p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL          -- message text
     );

--######################################################################################################################
--    HTML   ( 1  5  ), 
-- - ,   
-- :   ,   
-- mailer.HTML_UNIT(a1,'HTML_TO',' HTML_TO');
--######################################################################################################################
 PROCEDURE HTML_UNIT
     (p_to          IN LONG,     -- to -  
      p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL          -- message text
     ); 

--######################################################################################################################
--  CLOB         
-- mailer.CLOB_TEXT_FIX(p_subject => 'clob_text_FIX',
--                      p_message => '   clob_text_FIX',
--                      p_unix => false,
--                      p_text    =>  mailer.OPEN_CLOB(l_dir,'win.txt'));
--######################################################################################################################
 PROCEDURE CLOB_TEXT_FIX
     (p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL,         -- message text
      p_unix        IN BOOLEAN DEFAULT FALSE,     --   CLOB,  TRUE,   UNIX
      p_text        IN CLOB := EMPTY_CLOB         --  
     );     
     
--######################################################################################################################
--  CLOB         
-- mailer.CLOB_TEXT_TO(p_to      => l_to,
--                     p_subject => '  - clob_text_to',
--                     p_message => '   CLOB',
--                     p_unix => false,
--                     p_clob    =>  mailer.OPEN_CLOB(l_dir,'win.txt'));
--######################################################################################################################
 PROCEDURE CLOB_TEXT_TO
     (p_to          IN LONG,                  -- to
      p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL,         -- message text
      p_unix        IN BOOLEAN DEFAULT FALSE,     --   CLOB,  TRUE,   UNIX
      p_clob        IN CLOB := EMPTY_CLOB         --  
     );     

--######################################################################################################################
--  CLOB         
-- mailer.CLOB_TEXT_UNIT(p_to      => a1,
--                       p_subject => '  - clob_text_to',
--                       p_message => '   CLOB',
--                       p_unix => false,
--                       p_text    =>  mailer.OPEN_CLOB(l_dir,'win.txt'));
--######################################################################################################################
 PROCEDURE CLOB_TEXT_UNIT
     (p_to          IN LONG,     -- to
      p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL,         -- message text
      p_unix        IN BOOLEAN DEFAULT FALSE,     --   CLOB,  TRUE,   UNIX
      p_text        IN CLOB := EMPTY_CLOB         --  
     );     

--######################################################################################################################
--  CLOB      HTML   
-- mailer.CLOB_HTML_FIX(p_subject => 'clob_html_fix',
--                      p_message => '   clob_html_FIX',
--                      p_unix => false,
--                      p_html    =>  mailer.OPEN_CLOB(l_dir,'win.txt'));
--######################################################################################################################
 PROCEDURE CLOB_HTML_FIX
     (p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL,         -- message text
      p_unix        IN BOOLEAN DEFAULT FALSE,     --   CLOB,  TRUE,   UNIX
      p_html        IN CLOB := EMPTY_CLOB         --  
     );     
     
--######################################################################################################################
--  CLOB      HTML   
-- mailer.CLOB_HTML_TO(p_to      => l_to,
--                     p_subject => '  - clob_html_to',
--                     p_message => '   CLOB - clob_html_to',
--                     p_unix => false,
--                     p_html    =>  mailer.OPEN_CLOB(l_dir,'win.txt'));
--######################################################################################################################
 PROCEDURE CLOB_HTML_TO
     (p_to          IN LONG,                  -- to
      p_subject     IN VARCHAR2,                  -- subject
      p_message     IN LONG DEFAULT NULL,         -- message text
      p_unix        IN BOOLEAN DEFAULT FALSE,     --   CLOB,  TRUE,   UNIX
      p_html        IN CLOB := EMPTY_CLOB         --  
     );     
    
--######################################################################################################################
--  CLOB      HTML   
-- mailer.CLOB_HTML_UNIT(p_to      => a1,
--                       p_subject => '  - clob_html_to',
--                       p_message => '   CLOB - clob_html_to',
--                       p_unix => false,
--                       p_html    =>  mailer.OPEN_CLOB(l_dir,'win.txt'));
--######################################################################################################################
 PROCEDURE CLOB_HTML_UNIT
     (p_to          IN LONG,     -- to
      p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL,         -- message text
      p_unix        IN BOOLEAN DEFAULT FALSE,     --   CLOB,  TRUE,   UNIX
      p_html        IN CLOB := EMPTY_CLOB         --  
     );     

--######################################################################################################################
--  BLOB     
-- mailer.BLOB_FIX    (p_subject => 'blob_FIX test.jpeg',
--                     p_message => '  BLOB FIX test.jpeg',
--                     p_type    => 'application/octet-stream',
--                     p_name    => l_dir||'/test.jpeg',
--                     p_blob    =>  mailer.OPEN_BLOB(l_dir,'test.jpeg'));
--######################################################################################################################
 PROCEDURE BLOB_FIX
     (p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL,         -- message text
      p_type        IN VARCHAR2,                  --    
      p_name        IN VARCHAR2,                  --     
      p_blob        IN BLOB :=EMPTY_BLOB          --  blob
     );  
     
--######################################################################################################################
--  BLOB      
-- mailer.BLOB_TO     (p_to      => l_to,
--                     p_subject => ' BLOB - blob_to test.jpeg',
--                     p_message => '  BLOB test.jpeg',
--                     p_type    => 'application/octet-stream',
--                     p_name    => l_dir||'/test.jpeg',
--                     p_blob    =>  mailer.OPEN_BLOB(l_dir,'test.jpeg'));
--######################################################################################################################
 PROCEDURE BLOB_TO
     (p_to          IN LONG,                  -- to
      p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL,         -- message text
      p_type        IN VARCHAR2,                  --    
      p_name        IN VARCHAR2,                  --     
      p_blob        IN BLOB := EMPTY_BLOB         --  blob
     );     
   
--######################################################################################################################
--  BLOB     
-- mailer.BLOB_UNIT     (p_to      => a1,
--                       p_subject => ' BLOB - blob_to test.jpeg',
--                       p_message => '  BLOB test.jpeg',
--                       p_type    => 'application/octet-stream',
--                       p_name    => l_dir||'/test.jpeg',
--                       p_blob    =>  mailer.OPEN_BLOB(l_dir,'test.jpeg'));
--######################################################################################################################
 PROCEDURE BLOB_UNIT
     (p_to          IN LONG,     -- to
      p_subject     IN VARCHAR2 DEFAULT NULL,     -- subject
      p_message     IN LONG DEFAULT NULL,         -- message text
      p_type        IN VARCHAR2,                  --    
      p_name        IN VARCHAR2,                  --     
      p_blob        IN BLOB :=EMPTY_BLOB          --  blob
     );  

--######################################################################################################################
--         
-- mailer.MSG_TO(p_to => l_to,
--               p_unix => true,
--               p_clob => mailer.OPEN_CLOB(l_dir,'unix.msg')
--              );                    
--######################################################################################################################
 PROCEDURE MSG_TO
     (p_to          IN LONG,                   -- to
      p_unix        IN BOOLEAN DEFAULT FALSE,      --   CLOB,  TRUE,   UNIX
      p_clob        IN CLOB := EMPTY_CLOB          --  blob -    
     );  
    
--######################################################################################################################
--         
-- mailer.MSG_TO(p_to => l_to,
--               p_unix => false,
--               p_clob => mailer.OPEN_CLOB(l_dir,'win.msg')
--             );                    
--######################################################################################################################
 PROCEDURE MSG_UNIT
     (p_to          IN LONG,     -- to
      p_unix        IN BOOLEAN DEFAULT FALSE,     --   CLOB,  TRUE,   UNIX
      p_clob        IN CLOB := EMPTY_CLOB         --  blob -    
     );  

     
     
--######################################################################################################################
--######################################################################################################################
--######################################################################################################################
--           
 PROCEDURE R_A_Z_D_E_L;
--######################################################################################################################
--######################################################################################################################
--######################################################################################################################





     
--######################################################################################################################
--          
--######################################################################################################################
 FUNCTION INITIATOR
     (p_kak boolean
     ) RETURN LONG;

     
--######################################################################################################################
--  blob  64  -   
--######################################################################################################################
 PROCEDURE KODE_BLOB
     (p_blob        IN BLOB := EMPTY_BLOB         --  blob
     );
     
--######################################################################################################################
--     
--######################################################################################################################
 FUNCTION OPEN_CLOB
     (p_dir         IN VARCHAR2,                  -- directory  
      p_file        IN VARCHAR2                   -- ,   
     ) RETURN CLOB; 

--######################################################################################################################
--     
--######################################################################################################################
 FUNCTION OPEN_BLOB
     (p_dir         IN VARCHAR2,                  -- directory  
      p_file        IN VARCHAR2                   -- ,   
     ) RETURN BLOB; 

--######################################################################################################################
--     HTML-
--######################################################################################################################
 PROCEDURE TEXT_AS_HTML
     (p_message     IN LONG DEFAULT NULL,         -- message text
      p_kak         IN BOOLEAN DEFAULT FALSE      -- TRUE -  INITIATOR
     );
     
--######################################################################################################################
--      
--######################################################################################################################
 PROCEDURE INI_BOUND
     (p_type        IN VARCHAR2,                  --  
      P_bound       IN VARCHAR2                   --  boundary
     );

--######################################################################################################################
--       
--######################################################################################################################
 PROCEDURE START_BOUND
     (p_type        IN VARCHAR2,                  --  
      P_bound       IN VARCHAR2                   --  boundary
     );

--######################################################################################################################
--     boundary
--######################################################################################################################
 PROCEDURE NO_BOUND
     (p_type        IN VARCHAR2                   --  
     );
     
--######################################################################################################################
--           64 
--######################################################################################################################
 PROCEDURE APP_BOUND
     (p_type        IN VARCHAR2,                  --  
      p_name        IN VARCHAR2,                  --  
      P_bound       IN VARCHAR2                   --  boundary
     );
     
--######################################################################################################################
--   
--######################################################################################################################
 PROCEDURE STOP_BOUND
     (p_bound       IN VARCHAR2                   --  boundary
     );

--######################################################################################################################
--       ,   
--######################################################################################################################
 FUNCTION POST_RCPT        --   RCPT      
     (p_recipients   IN LONG  -- 
     ) RETURN LONG; 

--######################################################################################################################
--       ,   
--######################################################################################################################
 FUNCTION POST_CONN        --  ,  TRUE   
     (p_to            IN LONG
     )  RETURN LONG; 

--######################################################################################################################
--      ,   
--######################################################################################################################
 FUNCTION POST_HEADER
     (p_to          IN LONG,     -- to
      p_subject     IN VARCHAR2 DEFAULT NULL      -- subject
     ) RETURN boolean ;

--######################################################################################################################
--  CLOBa   
--######################################################################################################################
 PROCEDURE POST_CLOB
     (p_clob        IN CLOB := EMPTY_CLOB,       --  
      p_unix        IN BOOLEAN default FALSE     --  CLOB,   - WIN
     );     
   
--######################################################################################################################
--     .     ,   
--######################################################################################################################
 PROCEDURE POST_SEND;

          
--######################################################################################################################
--      ,   NULL  raise_application_error
--######################################################################################################################
 PROCEDURE ON_SEND_ERROR;

 
--######################################################################################################################
--     
--######################################################################################################################
 FUNCTION LT(lz in number) return varchar2; 

--######################################################################################################################
--       
--   english - writeData
--   - writeDataAsRaw
--   -    
--######################################################################################################################
 PROCEDURE writeData( p_text      IN VARCHAR2);
 PROCEDURE writeDataAsRaw( p_text IN VARCHAR2);

 END;
/
